import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class BookingExecutionService extends AbstractService<WorkflowExecution> {
  @override APIService<WorkflowExecution> service = APIService<WorkflowExecution>(
    baseURL: const String.fromEnvironment('DATACENTER_HOST', defaultValue: 'http://localhost:8000/datacenter')
  );
  @override String subPath = "/booking/";

  @override Future<APIResponse<WorkflowExecution>> search(BuildContext? context, List<String> words, Map<String, dynamic> params) {  
    return service.get("${subPath}search/${words.join("/")}", false, context);
  }

  @override Future<APIResponse<WorkflowExecution>> post(BuildContext? context, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
  @override Future<APIResponse<WorkflowExecution>> put(BuildContext? context, String id, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
}
