import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/logs.dart';
import 'package:oc_front/models/response.dart';

class LogsService extends AbstractService<LogsResult> {
  @override
  late final APIService<LogsResult> service;

  @override
  String subPath = "/loki/api/v1/";

  LogsService() {
    service = APIService<LogsResult>(
        baseURL: super.conf.get('LOGS_HOST', defaultValue: 'http://localhost:8000/tools/loki'));
  }

  @override
  Future<APIResponse<LogsResult>> search(
      BuildContext? context, List<String> words, Map<String, dynamic> params) {
    List<String> v = [];
    for (var p in params.keys) {
      if (p == "start" || p == "end") {
        continue;
      }
      v.add("$p=\"${params[p]}\"");
    } 
    return service.get("${subPath}query_range?query={${v.join(", ")}}&start=${params["start"].toString().substring(0, 10)}&end=${params["end"].toString().substring(0, 10)}", false, context);
  }

  @override
  Future<APIResponse<LogsResult>> get(BuildContext? context, String id) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> post(BuildContext? context,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> put(BuildContext? context, String id,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> delete(
      BuildContext? context, String id, Map<String, String> params) {
    throw UnimplementedError();
  }
}
