import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class WorflowService extends AbstractService<Workflow> {
  late final APIService<Check> serviceCheck;
  @override
  late final APIService<Workflow> service;
  @override
  String subPath = "/";

  WorflowService() {
    service = APIService<Workflow>(
        baseURL: super.conf.get('WORKFLOW_HOST',
            defaultValue: 'http://localhost:8000/workflow'));
    serviceCheck = APIService<Check>(
        baseURL: super.conf.get('WORKFLOW_HOST',
            defaultValue: 'http://localhost:8000/workflow'));
  }

  Future<APIResponse<Check>> check(
      BuildContext? context, List<String> words, Map<String, dynamic> params) {
    return serviceCheck.get("${subPath}check/${words.join("/")}", true, context);
  }
}
